unit Gem_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Spin;

type
  TForm1 = class(TForm)
    GridMatSoust: TStringGrid;
    GridSlPrStran: TStringGrid;
    GridElim: TStringGrid;
    GridSlElim: TStringGrid;
    Label2: TLabel;
    GridReseni: TStringGrid;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label4: TLabel;
    Label5: TLabel;
    EditDeterm: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    SpinEdit1: TSpinEdit;
    procedure Zadani(Sender: TObject);
    procedure Reseni(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure ZmenitPocet(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  Dalsi:Boolean;
implementation

{$R *.DFM}

const Max=10; {**** pocet rovnic ************}
var a    : array [1..Max,1..Max] of Double;
    b,x  : array [1..Max] of Double;
    n    : Integer;

procedure TForm1.Zadani(Sender: TObject);
var i,j:Integer;
begin
  n:=2;
  a[1,1]:=2.98;a[1,2]:=2.01;b[1]:=5.2;
  a[2,1]:=3.05;a[2,2]:=1.96;b[2]:=5.5;
  For i:=1 to n do
   begin
    For j:=1 to n do GridMatSoust.Cells[j-1,i-1]:=FloatToStr(a[i,j]);
    GridSlPrStran.Cells[0,i-1]:=FloatToStr(b[i]);
   end;
end;

Procedure Tisk;
var i,j:Integer;
begin
  For i:=1 to n do
   begin
    For j:=1 to n do
      Form1.GridElim.Cells[j-1,i-1]:=FloatToStr(a[i,j]);
    Form1.GridSlElim.Cells[0,i-1]:=FloatToStr(b[i]);
   end;
end;

procedure TForm1.Reseni(Sender: TObject);
const TemerNula=1e-8;
var i,j,k,r,Chyba   : integer;
    Trezor,Determinant: double;
begin
 {******************************************}
 {*****  nacteni zadani   ******************}
 {******************************************}
  For i:=1 to n do
   begin
    For j:=1 to n do if GridMatSoust.Cells[j-1,i-1]=''
                    then
                     a[i,j]:=0
                    else
                     a[i,j]:=StrToFloat(GridMatSoust.Cells[j-1,i-1]);
    if GridSlPrStran.Cells[0,i-1]=''
                    then b[i]:=0
                    else b[i]:=StrToFloat(GridSlPrStran.Cells[0,i-1]);
   end;
  {******************************************}
  {***** eliminace **************************}
  {******************************************}
   Dalsi:=False;
   for i:=1 to n-1 do                    {Postup po hl. diagonale}
    begin
      if abs(a[i,i])<TemerNula then          {Na hl. diagonale nula}
       begin
        k:=i;
        Repeat                               {Nalezeni nenuloveho prvku}
           k:=succ(k);
        until (abs(a[k,i])>TemerNula) or (k=n);
        if (a[i,i]<=0) and (k=n)
            then begin     {Nenulovy prvek nenalezen}
                   ShowMessage('Soustava nem jednoznan een');
                   exit;
                 end;
        for r:=i to n do                     {Prehozeni radku}
           begin
             Trezor:=a[k,r];a[k,r]:=a[i,r];
             a[i,r]:=Trezor;
           end;                              {Prehozeni radku}
        Trezor:=b[k];b[k]:=b[k];b[k]:=Trezor;{Prehozeni pravych stran}
       end;                                  {Na hl. diagonale nula}
       for k:=i+1 to n do                    {Nulovani pod a[i,i]}
       begin
         Trezor:=a[k,i]/a[i,i];
         a[k,i]:=0;
         for j:=i+1 to n do
            a[k,j]:=a[k,j]-Trezor*a[i,j];
         b[k]:=b[k]-Trezor*b[i];             {Eliminace prave strany}
      end;                                   {Nulovani pod a[i,i]}
   end;                                     {Postup po hl. diagonale}
 {******************************************}
 {*****  tisk soustavy po eliminaci ********}
 {******************************************}
 For i:=1 to n do
   begin
    For j:=1 to n do
      GridElim.Cells[j-1,i-1]:=FloatToStr(a[i,j]);
    GridSlElim.Cells[0,i-1]:=FloatToStr(b[i]);
   end;
 {******************************************}
 {***** zpetny chod ************************}
 {******************************************}
    if a[n,n]=0 then begin     {Nem een}
                     ShowMessage('Soustava nem jednoznan een');
                     exit;
                     end;
    for i:=1 to n do x[i]:=0;
    x[n]:=b[n]/a[n,n];
    for i:=n-1 downto 1 do                   {Zpet po hl. diaginale}
    begin
      for j:=i+1 to n do
          x[i]:=x[i]+a[i,j]*x[j];            {Secteni radku}
      x[i]:=(b[i]-x[i])/a[i,i];              {vypocet i-te slozky reseni}
    end;                                     {Zpet po hl. diagonale}
 {******************************************}
 {***** tisk vysledku **********************}
 {******************************************}
 for i:=1 to n do
   GridReseni.Cells[0,i-1]:=FloatToStr(x[i]);

 Determinant:=1;
 for i:=1 to n do Determinant:=Determinant*a[i,i];
 EditDeterm.Text:=FloatToStr(Determinant);
end;

procedure TForm1.Finish(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.ZmenitPocet(Sender: TObject);
var i,j:Integer;
begin
  n:=SpinEdit1.Value;
  With GridMatSoust do begin
                         ColCount:=n;
                         RowCount:=n;
                       end;
  With GridElim     do begin
                         ColCount:=n;
                         RowCount:=n;
                       end;
  GridSlPrStran.RowCount:=n;
  GridSlElim.RowCount:=n;
  GridReseni.RowCount:=n;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Dalsi:=True;
end;

end.
