unit LU_Unit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids, Spin;

type
  TForm1 = class(TForm)
    GridMatSoust: TStringGrid;
    GridSlPrStran: TStringGrid;
    Grid_U: TStringGrid;
    GridSlElim: TStringGrid;
    Label2: TLabel;
    GridReseni: TStringGrid;
    Label3: TLabel;
    Button1: TButton;
    Button2: TButton;
    Label4: TLabel;
    Label5: TLabel;
    EditDeterm: TEdit;
    Label6: TLabel;
    Label7: TLabel;
    SpinEdit1: TSpinEdit;
    CheckBox1: TCheckBox;
    Button3: TButton;
    Grid_L: TStringGrid;
    Label1: TLabel;
    Grid_LU: TStringGrid;
    Label8: TLabel;
    procedure Zadani(Sender: TObject);
    procedure Reseni(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure ZmenitPocet(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;
  Dalsi:Boolean;
implementation

{$R *.DFM}

const Max=10; {**** pocet rovnic ************}
var a,L,U,LU: array [1..Max,1..Max] of Double;
    b,x     : array [1..Max] of Double;
    n       : Integer;

procedure TForm1.Zadani(Sender: TObject);
var i,j:Integer;
begin
  n:=4;
  a[1,1]:=-1;a[1,2]:=1;a[1,3]:=3;a[1,4]:=2;b[1]:=10;
  a[2,1]:=3;a[2,2]:=2;a[2,3]:=1;a[2,4]:=-1;b[2]:=0;
  a[3,1]:=2;a[3,2]:=3;a[3,3]:=-1;a[3,4]:=1;b[3]:=0;
  a[4,1]:=1;a[4,2]:=-1;a[4,3]:=2;a[4,4]:=3;b[4]:=15;
  For i:=1 to n do
   begin
    For j:=1 to n do GridMatSoust.Cells[j-1,i-1]:=FloatToStr(a[i,j]);
    GridSlPrStran.Cells[0,i-1]:=FloatToStr(b[i]);
   end;
end;

Procedure Tisk;
var i,j:Integer;
begin
  For i:=1 to n do
   begin
    For j:=1 to n do
      Form1.Grid_U.Cells[j-1,i-1]:=FloatToStr(U[i,j]);
    Form1.GridSlElim.Cells[0,i-1]:=FloatToStr(b[i]);
   end;
end;

procedure TForm1.Reseni(Sender: TObject);
const TemerNula=1e-8;
var i,j,k,Chyba       : integer;
    Trezor,Determinant: double;
    Vypis             :String;
begin
 {******************************************}
 {*****  nacteni zadani   ******************}
 {******************************************}
  For i:=1 to n do
   begin
    For j:=1 to n do if GridMatSoust.Cells[j-1,i-1]=''
                    then
                     a[i,j]:=0
                    else
                     a[i,j]:=StrToFloat(GridMatSoust.Cells[j-1,i-1]);
    if GridSlPrStran.Cells[0,i-1]=''
                    then b[i]:=0
                    else b[i]:=StrToFloat(GridSlPrStran.Cells[0,i-1]);
   end;

  U:=A;
  For i:=1 to n do
    For j:=1 to n do if i=j then L[i,j]:=1
                            else L[i,j]:=0;

  {******************************************}
  {***** eliminace **************************}
  {******************************************}
   Dalsi:=False;
   for i:=1 to n-1 do                    {Postup po hl. diagonale}
    begin
      if abs(U[i,i])<TemerNula then          {Na hl. diagonale nula}
       begin
        k:=i;
        Repeat                               {Nalezeni nenuloveho prvku}
           k:=succ(k);
        until (abs(U[k,i])>TemerNula) or (k=n);
        if (U[i,i]<=0) and (k=n)
            then begin     {Nenulovy prvek nenalezen}
                   ShowMessage('Soustava nem jednoznan een');
                   exit;
                 end;
        for j:=i to n do                     {Prehozeni radku}
           begin
             Trezor:=U[k,j];U[k,j]:=U[i,j];
             U[i,j]:=Trezor;
           end;                              {Prehozeni radku}
        Trezor:=b[k];b[k]:=b[k];b[k]:=Trezor;{Prehozeni pravych stran}
       end;                                  {Na hl. diagonale nula}
       for k:=i+1 to n do                    {Nulovani pod a[i,i]}
       begin
         L[k,i]:=U[k,i]/U[i,i];
         for j:=i to n do
            U[k,j]:=U[k,j]-L[k,i]*U[i,j];
         b[k]:=b[k]-L[k,i]*b[i];          {Eliminace prave strany}
        
      if CheckBox1.Checked then
      begin
         Str(L[k,i]:3:2,Vypis);
         Grid_L.Cells[i-1,k-1]:=Vypis;
         Tisk;
         Repeat
         Application.Processmessages;
         Until dalsi;
         dalsi:=False;
      end;
      end;                                   {Nulovani pod a[i,i]}
    
    end;                                     {Postup po hl. diagonale}
 {******************************************}
 {*****  tisk soustavy po eliminaci ********}
 {******************************************}
 For i:=1 to n do
   begin
    For j:=1 to n do
      Grid_U.Cells[j-1,i-1]:=FloatToStr(U[i,j]);
    GridSlElim.Cells[0,i-1]:=FloatToStr(b[i]);
   end;

 For i:=1 to n do
    For j:=1 to n do
      Grid_L.Cells[j-1,i-1]:=FloatToStr(L[i,j]);

 {souin LU}
 For i:=1 to n do
    For j:=1 to n do LU[i,j]:=0;

 For i:=1 to n do
   For j:=1 to n do
     For k:=1 to n do
       LU[i,j]:=LU[i,j]+L[i,k]*U[k,j];

 For i:=1 to n do
    For j:=1 to n do
      Grid_LU.Cells[j-1,i-1]:=FloatToStr(LU[i,j]);

 {******************************************}
 {***** zpetny chod ************************}
 {******************************************}
    if U[n,n]=0 then begin     {Nem een}
                     ShowMessage('Soustava nem jednoznan een');
                     exit;
                     end;
    for i:=1 to n do x[i]:=0;
    x[n]:=b[n]/U[n,n];
    for i:=n-1 downto 1 do                   {Zpet po hl. diaginale}
    begin
      for j:=i+1 to n do
          x[i]:=x[i]+U[i,j]*x[j];            {Secteni radku}
      x[i]:=(b[i]-x[i])/U[i,i];              {vypocet i-te slozky reseni}
    end;                                     {Zpet po hl. diagonale}
 {******************************************}
 {***** tisk vysledku **********************}
 {******************************************}
 for i:=1 to n do
   GridReseni.Cells[0,i-1]:=FloatToStr(x[i]);

 Determinant:=1;
 for i:=1 to n do Determinant:=Determinant*U[i,i];
 EditDeterm.Text:=FloatToStr(Determinant);
end;

procedure TForm1.Finish(Sender: TObject);
begin
  Application.Terminate;
end;

procedure TForm1.ZmenitPocet(Sender: TObject);
var i,j:Integer;
begin
  n:=SpinEdit1.Value;
  With GridMatSoust do begin
                         ColCount:=n;
                         RowCount:=n;
                       end;
  With Grid_U     do begin
                         ColCount:=n;
                         RowCount:=n;
                       end;
  GridSlPrStran.RowCount:=n;
  GridSlElim.RowCount:=n;
  GridReseni.RowCount:=n;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  Dalsi:=True;
end;

end.
