unit Roulette;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TForm1 = class(TForm)
    MatrixStringGrid: TStringGrid;
    Next_StringGrid: TStringGrid;
    Label1: TLabel;
    Prev_StringGrid: TStringGrid;
    Label2: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Label7: TLabel;
    procedure Setting(Sender: TObject);
    procedure Bet(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


Const MaxIndex           = 3000;
      MaxTableIndex      = 21;
      Profit_Possibility = 18/37;
      Loss_Possibility   = 19/37;

Type TVector = array [0..MaxIndex] of double;
     TMatrix = array [0..MaxIndex,0..MaxIndex] of double;
var
  Form1: TForm1;
  Prev_Likelihood_Vec,
  Next_Likelihood_Vec:TVector;
  T                  :TMatrix;
  NoOfBet            :Integer;
  ZeroLikeliHood     :Double;
implementation

{$R *.DFM}

  Function Product(var T:TMatrix;var Vec:TVector):TVector;
  var i, j:Integer;
      Pom :TMatrix;
  begin
    for i:=0 to MaxIndex do Result[i]:=0;
    For i:=0 to MaxIndex do
      For j:= 0 to MaxIndex do
           Result[i]:=Result[i]+T[i,j]*Vec[j];
  end;

procedure TForm1.Setting(Sender: TObject);
var i,j,Difference:Integer;
    NumberNotation:String;
begin
  For i:=0 to MaxIndex do  Prev_Likelihood_Vec[i]:=0;
  Prev_Likelihood_Vec[10]:=1;
  Prev_StringGrid.Cells[0,9]:='1';
  ZeroLikeliHood:=0;
 { For i:=1 to MaxTableIndex do
      Prev_StringGrid.Cells[0,i-1]:=FloatToStr(Prev_Likelihood_Vec[i]);}

  i:=0;j:=0;
  Repeat
     Prev_StringGrid.Cells[1,j]:=IntToStr(i);
     i:=i+50;j:=succ(j);
  until j=MaxTableIndex;

  for i:=0 to MaxTableIndex-1 do
                        Next_StringGrid.Cells[0,i]:=Prev_StringGrid.Cells[1,i];

  Next_StringGrid.Cells[0,0]:=              'ebrk';
  Next_StringGrid.Cells[0,MaxTableIndex-1]:='Boh';

  for i:=0 to MaxIndex do
     for j:=0 to MaxIndex do T[i,j]:=0;
  Difference:=2;i:=1;
  for j:=2 to MaxIndex do
  begin
           T[i,j]           :=Loss_Possibility;
           if i+Difference<=MaxIndex then T[i+Difference,j]:=Profit_Possibility
                                     else T[MaxIndex,j]:=Profit_Possibility;
           if not odd(j) then inc(i)
                         else Difference:=Difference+2;
  end;

  for i:=1 to MaxIndex do
     for j:=1 to MaxIndex do
     begin
     if abs(T[i,j]-Loss_Possibility)<1e-3
         then MatrixStringGrid.Cells[j-1,i-1]:='P'
         else if abs(T[i,j]-Profit_Possibility)<1e-3
                 then MatrixStringGrid.Cells[j-1,i-1]:='V'
   {              else if T[i,j]=1 then MatrixStringGrid.Cells[j-1,i-1]:='1'
                                  else MatrixStringGrid.Cells[j-1,i-1]:='0';}
     end;
  Label7. Caption:='poet szek: 0';
  NoOfBet:=0;
end;

procedure TForm1.Bet(Sender: TObject);
var i             :Integer;
    NumberNotation    :String;
    Summ,SummMin,SummMax:Double;
    Suma                :Double;
begin
 for i:=1 to MaxTableIndex do
    begin
       Str(Prev_Likelihood_Vec[i]:4:3,NumberNotation);
       if abs(Prev_Likelihood_Vec[i])>1e-3 then Prev_StringGrid.Cells[0,i-1]:=NumberNotation
                                           else Prev_StringGrid.Cells[0,i-1]:='';
    end;
 Suma :=0;
 For i:=MaxTableIndex+1 to MaxIndex do
                     Suma:=Suma+Prev_Likelihood_Vec[i];
 Str(suma:4:3,NumberNotation);                    
 if suma>0 then
 Prev_StringGrid.Cells[0,MaxTableIndex-1]:=NumberNotation;

 Next_Likelihood_Vec:=Product(T,Prev_Likelihood_Vec);
 Next_Likelihood_Vec[1]:=Next_Likelihood_Vec[1]+Prev_Likelihood_Vec[1];
 for i:=1 to MaxTableIndex-1 do
    begin
       Str(Next_Likelihood_Vec[i]:4:3,NumberNotation);
       if abs(Next_Likelihood_Vec[i])>1e-3 then Next_StringGrid.Cells[1,i-1]:=NumberNotation
                                           else Next_StringGrid.Cells[1,i-1]:='';
    end;
  Suma :=0;
  For i:=MaxTableIndex+1 to MaxIndex do
                     Suma:=Suma+Next_Likelihood_Vec[i];
  Str(suma:4:3,NumberNotation);
  if suma>0 then
  Next_StringGrid.Cells[1,MaxTableIndex-1]:=NumberNotation;
{ Summ:=0;
 for i:=0 to MaxTableIndex-1 do Summ:=Summ+Next_Likelihood_Vec[i];
 Str(1-Summ:4:3,NumberNotation);
 Next_StringGrid.Cells[1,MaxTableIndex-1]:=NumberNotation;}
 Prev_Likelihood_Vec:=Next_Likelihood_Vec;

 inc(NoOfBet);
 Str(NoOfBet,NumberNotation);
 Label7.Caption:='poet szek:   '+NumberNotation;
end;

end.
