unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Grids;

type
  TForm1 = class(TForm)
    MatrixStringGrid: TStringGrid;
    Next_StringGrid: TStringGrid;
    Label1: TLabel;
    Prev_StringGrid: TStringGrid;
    Label2: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Button1: TButton;
    Label7: TLabel;
    procedure Setting(Sender: TObject);
    procedure Bet(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;


Const MaxIndex           = 30;
      Profit_Possibility = 18/37;
      Loss_Possibility   = 19/37;

Type TVector = array [1..MaxIndex] of double;
     TMatrix = array [1..MaxIndex,1..MaxIndex] of double;
var
  Form1: TForm1;
  Prev_Likelihood_Vec,
  Next_Likelihood_Vec:TVector;
  T                  :TMatrix;
  NoOfBet            :Integer;

implementation

{$R *.DFM}

  Function Direct(T:TMatrix;Vec:TVector):TVector;
  var i, j:Integer;
      Pom :TMatrix;
  begin
    for i:=1 to MaxIndex do Result[i]:=0;
    For i:=1 to MaxIndex do
      For j:=1 to MaxIndex do
           Result[i]:=Result[i]+T[i,j]*Vec[j];
  end;

procedure TForm1.Setting(Sender: TObject);
var i,j,Difference:Integer;
    NumberNotation:String;
begin
  For i:=1 to MaxIndex do  Prev_Likelihood_Vec[i]:=0;
  Prev_Likelihood_Vec[9]:=1;
  For i:=1 to MaxIndex do
      Prev_StringGrid.Cells[0,i-1]:=FloatToStr(Prev_Likelihood_Vec[i]);

  i:=0;j:=0;
  Repeat
     Prev_StringGrid.Cells[1,j]:=IntToStr(i);
     i:=i+50;j:=succ(j);
  until j=MaxIndex;

  for i:=0 to MaxIndex-1 do
                        Next_StringGrid.Cells[0,i]:=Prev_StringGrid.Cells[1,i];

  for i:=1 to MaxIndex do
     for j:=1 to MaxIndex do T[i,j]:=0;
  Difference:=2;i:=1;
  for j:=2 to MaxIndex do
  begin
    if j<21
      then begin
             T[i,j]           :=Loss_Possibility;
             if i+Difference<=MaxIndex then T[i+Difference,j]:=Profit_Possibility
                              else T[MaxIndex,j]:=Profit_Possibility;
             if not odd(j) then inc(i)
                           else Difference:=Difference+2;
           end
      else T[j,j]:=1;                     
  End;

  for i:=1 to MaxIndex do
     for j:=1 to MaxIndex do
     begin
     if abs(T[i,j]-Loss_Possibility)<1e-3
         then MatrixStringGrid.Cells[j-1,i-1]:='p1'
         else if abs(T[i,j]-Profit_Possibility)<1e-3
                 then MatrixStringGrid.Cells[j-1,i-1]:='p2'
                 else if T[i,j]=1 then MatrixStringGrid.Cells[j-1,i-1]:='1'
                                  else MatrixStringGrid.Cells[j-1,i-1]:='0';
     end;
  Label7. Caption:='poet szek: 0';
  NoOfBet:=0;
end;

procedure TForm1.Bet(Sender: TObject);
var i             :Integer;
    NumberNotation:String;
    Summ          :Double;

begin
 for i:=1 to MaxIndex do
    begin
       Str(Prev_Likelihood_Vec[i]:4:3,NumberNotation);
       Prev_StringGrid.Cells[0,i-1]:=NumberNotation;
    end;
 Next_Likelihood_Vec:=Direct(T,Prev_Likelihood_Vec);
 for i:=1 to MaxIndex do
    begin
       Str(Next_Likelihood_Vec[i]:4:3,NumberNotation);
       Next_StringGrid.Cells[1,i-1]:=NumberNotation;
    end;
 Prev_Likelihood_Vec:=Next_Likelihood_Vec;
 Summ:=0;
 for i:=1 to MaxIndex do Summ:=Summ+Prev_Likelihood_Vec[i];
 Str(Summ:4:3,NumberNotation);
 inc(NoOfBet);
 Str(NoOfBet,NumberNotation);
 Label7.Caption:=' poet szek:   '+NumberNotation;
end;

procedure TForm1.Button2Click(Sender: TObject);
var i,j,Code:Integer;
    NumberNotation:String;
   
begin
  For i:=1 to MaxIndex do
    Prev_Likelihood_Vec[i]:=StrToFloat(Prev_StringGrid.Cells[0,i-1]);

  For i:=1 to MaxIndex do Next_Likelihood_Vec[i]:=0;
  For i:=1 to MaxIndex do
      Next_StringGrid.Cells[1,i-1]:=FloatToStr(Next_Likelihood_Vec[i]);

  For i:=1 to MaxIndex do
    For j:=1 to MaxIndex do
      Val(MatrixStringGrid.Cells[j-1,i-1],T[i,j],Code);
end;

end.
